#include "AdaptiveMesh.h"

AdaptiveMesh::AdaptiveMesh ( int numComponents ) : Mesh ( numComponents )
{
	vertices = new AdaptiveArray<Vertex> ( 128 );
	faces = new AdaptiveArray<Face> ( 128 );
}

AdaptiveMesh::~AdaptiveMesh ( void )
{
	delete vertices;
	delete faces;
}

void AdaptiveMesh::clearFaces ( void )
{
	faces->clear ( );
}

void AdaptiveMesh::clearVertices ( void )
{
	vertices->clear ( );
}

int AdaptiveMesh::getNumFaces ( void )
{
	return faces->getSize ( );
}

int AdaptiveMesh::getNumVertices ( void )
{
	return vertices->getSize ( );
}

int AdaptiveMesh::addFace ( Face* face )
{
	int index = faces->getNewElement ( );

	(faces->getElement ( index )).copy ( face );

	return index;
}

Face* AdaptiveMesh::getFace ( int i )
{
	return &faces->getElement ( i );
}

int AdaptiveMesh::addVertex ( Vertex *vertex )
{
	vertices->insertElement ( *vertex );

	return getNumVertices ( ) - 1;
}

Vertex* AdaptiveMesh::getVertex ( int i )
{
	return &vertices->getElement ( i );
}


void AdaptiveMesh::removeFace ( int i )
{
	faces->removeElement ( i );
}

void AdaptiveMesh::removeVertex ( int x )
{
	int i, j;

	vertices->removeElement ( x );

	for ( i = 0; i < getNumFaces ( ); i++ )
	{
		Face *f = getFace ( i );

		for ( j = 0; j < f->getLength ( ); j++ )
		{
			if ( f->getData ( ) [ j ] == x )
			{
				// delete this face
				removeFace ( i );
				i--;
				break;
			}
			else
			{
				if ( f->getData ( ) [ j ] == getNumVertices ( ) )
				{
					f->getData ( ) [ j ] = x;
				}
			}
		}
	}
}