/** \file
\brief Parsing functions
\author Josiah Manson

Modified: June 26, 2006
I'm so confused about what version is the newest. some consolidation taken place

Modified: June 20, 2005
Added the functions readIntInline

Modified: July 28, 2005
Some stuff. Use it.
**/


#pragma once
//#pragma warning (disable : 4786)

#ifndef _file_inline_h
#define _file_inline_h

#ifndef WIN32
#define __int8 char
#define __int16 short
#define __int32 int
#define __int64 long long
#endif

#include <string>
#include <vector>
#include <fstream>
#include <sstream>

using namespace std;

/////// toStr
template<class type> inline string toStr(const type &value)
{
    ostringstream streamOut;
	streamOut.flags(ios::fixed);
    streamOut << value;
    return streamOut.str();
}

///// inline file stuff
template <class T> void writeInline(ostream& f, const T& v)
{
	f.write((char*)&v, sizeof(T));
}

template <class T> void writeInline(ostream& f, const T *v, __int32 num)
{
	f.write((char*)v, sizeof(T)*num);
}

template <class T> void writeInline(ostream& f, const vector<T>& v)
{
	writeInline(f, v.size());
	writeInline(f, &v[0], (int)v.size());
}

template <class T> void readInline(istream& f, T& v)
{
	f.read((char*)&v, sizeof(T));
}

template <class T> void readInline(istream& f, T *v, volatile __int32 num)
{
	f.read((char*)v, sizeof(T)*num);
}

template <class T> void readInline(istream& f, vector<T>& v)
{
	volatile __int32 s;
	readInline(f, s);
	v.resize(s);
	readInline(f, &v[0], s);
}

template <class T> void writeInline(ostream& f, const string& s)
{
	volatile __int32 num = s.size();
	writeInline(f, num);
	f.write((char*)s.c_str(), num);
}

template <class T> void readInline(istream& f, string& s)
{
	volatile __int32 num;
	readInline(f, num);
	
	char *ptr = new char [num + 1];
	ptr[num] = 0;
	
	f.read(ptr, num);
	s = ptr;
	
	delete [] ptr;
}

#endif