#include "Mesh.h"
#include <set>

using namespace std;

// implements Taubin's non-shrinking smoothing

void Mesh::smooth ( int iterations )

{

      int i, j, k, ii;

      int *val = new int [ getNumVertices ( ) ];

      float **avg = new float *[ getNumVertices ( ) ];

      set<int> *verts = new set<int> [ getNumVertices ( ) ];

      bool *boundary = new bool [ getNumVertices ( ) ];

 

      memset ( val, 0, sizeof ( int ) * getNumVertices ( ) );

 

      for ( i = 0; i < getNumVertices ( ); i++ )

      {

            avg [ i ] = new float [ 3 ];

      }

 

      // if verts [ i ].size ( ) != val [ i ], then boundary vertex

      for ( i = 0; i < getNumFaces ( ); i++ )

      {

            Face *f = getFace ( i );

 

            for ( j = 0; j < f->getLength ( ); j++ )

            {

                  val [ f->getData ( ) [ j ] ]++;

                  verts [ f->getData ( ) [ ( j + 1 ) % f->getLength ( ) ] ].insert ( f->getData ( ) [ j ] );

                  verts [ f->getData ( ) [ ( j + 1 ) % f->getLength ( ) ] ].insert ( f->getData ( ) [ ( j + 2 ) % f->getLength ( ) ] );

            }

      }

 

      for ( i = 0; i < getNumVertices ( ); i++ )

      {

            if ( verts [ i ].size ( ) != val [ i ] )

            {

                  boundary [ i ] = true;

                  val [ i ] = 0;

            }

            else

            {

                  boundary [ i ] = false;

            }

      }

 

      // compute valence for boundary vertices

      for ( i = 0; i < getNumFaces ( ); i++ )

      {

            Face *f = getFace ( i );

 

            for ( j = 0; j < f->getLength ( ); j++ )

            {

                  int curr = f->getData ( ) [ ( j + 1 ) % f->getLength ( ) ];

                  int next = f->getData ( ) [ ( j + 2 ) % f->getLength ( ) ];

                  int prev = f->getData ( ) [ j ];

 

                  if ( boundary [ curr ] )

                  {

/*                      if ( boundary [ prev ] )

                        {

                              val [ curr ]++;

                        }

                        if ( boundary [ next ] )

                        {

                              val [ curr ]++;

                        }*/

                        val [ curr ] = 1;

                  }

            }

      }

 

      for ( i = 0; i < iterations; i++ )

      {

            // compute average

            for ( j = 0; j < getNumVertices ( ); j++ )

            {

                  memset ( avg [ j ], 0, sizeof ( float ) * 3 );

            }

 

            for ( j = 0; j < getNumFaces ( ); j++ )

            {

                  Face *f = getFace ( j );

 

                  for ( k = 0; k < f->getLength ( ); k++ )

                  {

                        int curr = f->getData ( ) [ ( k + 1 ) % f->getLength ( ) ];

                        int prev = f->getData ( ) [ k ];

                        int next = f->getData ( ) [ ( k + 2 ) % f->getLength ( ) ];

                        float *v1 = getVertex ( prev )->getVert ( );

                        float *v2 = getVertex ( next )->getVert ( );

                        if ( boundary [ curr ] )

                        {

/*                            // boundary vertex... only average other boundary vertices

                              if ( boundary [ prev ] )

                              {

                                    for ( ii = 0; ii < 3; ii++ )

                                    {

                                          avg [ curr ] [ ii ] += v1 [ ii ];

                                    }

                              }

                              if ( boundary [ next ] )

                              {

                                    for ( ii = 0; ii < 3; ii++ )

                                    {

                                          avg [ curr ] [ ii ] += v2 [ ii ];

                                    }

                              }*/

                              for ( ii = 0; ii < 3; ii++ )

                              {

                                    avg [ curr ] [ ii ] = getVertex ( curr )->getVert ( ) [ ii ];

                              }

                        }

                        else

                        {

                              for ( ii = 0; ii < 3; ii++ )

                              {

                                    avg [ curr ] [ ii ] += ( v1 [ ii ] + v2 [ ii ] ) / 2;

                              }

                        }

                  }

            }

 

            // smooth vertex positions

            for ( j = 0; j < getNumVertices ( ); j++ )

            {

                  float *v = getVertex ( j )->getVert ( );

 

                  if ( val [ j ] != 0 )

                  {

                        for ( k = 0; k < 3; k++ )

                        {

                              avg [ j ] [ k ] = v [ k ] - avg [ j ] [ k ] / ( val [ j ] );

                              if ( avg [ j ] [ k ] > 10 )

                              {

                                    printf ( "bad\n" );

                              }

                        }

                        if ( ( i % 2 ) == 1 )

                        {

                              v [ 0 ] = v [ 0 ] - avg [ j ] [ 0 ] * .6307;

                              v [ 1 ] = v [ 1 ] - avg [ j ] [ 1 ] * .6307;

                              v [ 2 ] = v [ 2 ] - avg [ j ] [ 2 ] * .6307;

                        }

                        else

                        {

                              v [ 0 ] = v [ 0 ] + avg [ j ] [ 0 ] * .673156;

                              v [ 1 ] = v [ 1 ] + avg [ j ] [ 1 ] * .673156;

                              v [ 2 ] = v [ 2 ] + avg [ j ] [ 2 ] * .673156;

                        }

                  }

            }

      }

 

      delete[] val;

 

      for ( i = 0; i < getNumVertices ( ); i++ )

      {

            delete[] avg [ i ];

      }

      delete[] avg;

      delete[] verts;

      delete[] boundary;

}
