// Author: Josiah Manson

#include "pointset.h"
#include "file_inline.h"
#include <float.h>

void findExtents(vector<OrientedPoint> &pts, vect3f &mine, vect3f &maxe)
{
	if (pts.empty())
		return;

	mine = maxe = pts[0].pos;

	for (unsigned int k = 1; k < pts.size(); k++)
	{
		for (int i = 0; i < 3; i++)
		{
			mine[i] = min(mine[i], pts[k].pos[i]);
			maxe[i] = max(maxe[i], pts[k].pos[i]);
		}
	}
}

void squareExtents(vect3f &mine, vect3f &maxe)
{
	// increase size a little bit
	float border = .1f;
	vect3f dif = maxe - mine;
	maxe += dif*border;
	mine -= dif*border;

	// make square
	dif = maxe - mine;
	float mdif = max(dif[0], max(dif[1], dif[2]));

	for (int i = 0; i < 3; i++)
	{
		if (dif[i] < mdif)
		{
			float fix = (mdif - dif[i])*0.5f;
			maxe[i] += fix;
			mine[i] -= fix;
		}
	}
}

void PointSet::writePts(string filename)
{
	ofstream file(filename.c_str(), ios_base::binary);

	writeInline(file, mine);
	writeInline(file, maxe);
	writeInline(file, points);
	
	file.close();
}
